#include <stdio.h>
#include <gl/glut.h>

#define abs(a) ((a)<0 ? -(a) : (a))
#define sgn(a) ((a)<0 ? -1 : 1)

#define MAX_X	666
#define MAX_Y	444
#define MAX_N	100

typedef struct {
	int x, y, z, i;
} tocka_t;

int n[2];
int L[MAX_Y], D[MAX_Y];
int Li[MAX_Y], Di[MAX_Y];
int Lz[MAX_Y], Dz[MAX_Y];
int Zbuffer[MAX_X*MAX_Y];
tocka_t t[2][MAX_N];


void dda (int ys, int ye, int xs, int xe, int *L, int *D)
{
	int y, xi, xf, mi, mf;

	if (ys == ye) {
		if (xs < xe)
			L[ys] = xs;
		else
			D[ys] = xs;
	}
	else {
		xi = xs;
		xf = - abs (ye - ys);
		mi = abs ((xe - xs) / (ye - ys));
		mf = 2 * abs ((xe - xs) % (ye - ys));
		for (y = ys; y != ye + sgn (ye - ys); y += sgn (ye - ys)) {
			if (ye < ys)
				L[y] = xi;
			else
				D[y] = xi;
			xi += mi * sgn (xe - xs);
			xf += mf;
			if (xf >= 0) {
				xi += sgn (xe - xs);
				xf -= 2 * abs (ye - ys);
			}
		}
	}
}


void obradaPrikaza (void)
{
	int p, i, j, x, y;
	int z;

	glClear (GL_COLOR_BUFFER_BIT);
	memset (Zbuffer, 0x7f, sizeof (Zbuffer));
	printf ("%d je Z...\n", Zbuffer[0]);

	for (p=0; p<2; p++) {

		for (y=0; y <= MAX_Y; y++)
			L[y] = D[y] = Lz[y] = Dz[y] = Li[y] = Di[y] = 0;

		for (i=0; i < n[p]; i++) {
			j = (i+1) % n[p];

			dda (t[p][i].y, t[p][j].y, t[p][i].x, t[p][j].x, L, D);
			dda (t[p][i].y, t[p][j].y, t[p][i].i, t[p][j].i, Li, Di);
			dda (t[p][i].y, t[p][j].y, t[p][i].z, t[p][j].z, Lz, Dz);
		}

		for (y=0; y <= MAX_Y; y++)
			if (L[y] || D[y]) {
				glColor3f (0.8, 0.7, 0.7);
				glBegin (GL_POINTS);
				for (x=0; x <= D[y]-L[y]; x++) {
					i = Li[y];
					if (x > 0 && Di[y] != Li[y])
						i += (Di[y]-Li[y]) * x / (D[y]-L[y]);
					z = Lz[y];
					if (x > 0 && Dz[y] != Lz[y])
						z += (Dz[y]-Lz[y]) * x / (D[y]-L[y]);
					if (z < Zbuffer[y*MAX_X + L[y] + x]) {
						if (p == 0)
							glColor3f (0.2 + i*0.1/256, 0.3 + i*0.6/256, 0.2 + i*0.1/256);
						else
							glColor3f (0.2 + i*0.1/256, 0.2 + i*0.1/256, 0.3 + i*0.6/256);
						glVertex2i (L[y] + x, y);
						Zbuffer[y*MAX_X + L[y] + x] = z;
					}
				}
				glEnd ();
			}
	}

	glutSwapBuffers ();
}


void citanjeDatoteke (char *datoteka)
{
	FILE *f;
	int i, j;

	f = fopen (datoteka, "r");
	if (!f) {
		printf ("Datoteka %s ne postoji!?\n", datoteka);
		exit (1);
	}

	for (i=0; i < 2; i++) {
		fscanf (f, "%d", &(n[i]));
		for (j=0; j < n[i]; j++)
			if (fscanf (f, "%d %d %d %d", &(t[i][j].x), &(t[i][j].y), &(t[i][j].z), &(t[i][j].i)) != 4) {
				printf ("Molimo osigurajte da je datoteka %s u ispravnom formatu.\n", datoteka);
				exit (1);
			}
	}
}


void main (int argc, char *argv[])
{
	char *datoteka = "ulaz.txt";

	if (argc == 2)
		datoteka = argv[1];
	citanjeDatoteke (datoteka);

	glutInit (&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE);
	glutInitWindowPosition (100,100);
	glutInitWindowSize (MAX_X, MAX_Y);
	glutCreateWindow ("Laboratorijska vjezba 6");

	glOrtho (0, MAX_X, 0, MAX_Y, 0, 1); 
	glClearColor (1.0, 1.0, 1.0, 1.0);
	glColor3f (0.4, 0.4, 0.4);

	glutDisplayFunc (obradaPrikaza);
	glutMainLoop ();
}